// Code generated by ent, DO NOT EDIT.

package post

import (
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
)

const (
	// Label holds the string label denoting the post type in the database.
	Label = "post"
	// FieldID holds the string denoting the id field in the database.
	FieldID = "id"
	// FieldImage holds the string denoting the image field in the database.
	FieldImage = "image"
	// FieldContent holds the string denoting the content field in the database.
	FieldContent = "content"
	// FieldProfileDisplayname holds the string denoting the profile_displayname field in the database.
	FieldProfileDisplayname = "profile_displayname"
	// FieldProfileBirthYear holds the string denoting the profile_birth_year field in the database.
	FieldProfileBirthYear = "profile_birth_year"
	// FieldProfileGender holds the string denoting the profile_gender field in the database.
	FieldProfileGender = "profile_gender"
	// FieldCoordinates holds the string denoting the coordinates field in the database.
	FieldCoordinates = "coordinates"
	// FieldCreatedAt holds the string denoting the created_at field in the database.
	FieldCreatedAt = "created_at"
	// FieldUpdatedAt holds the string denoting the updated_at field in the database.
	FieldUpdatedAt = "updated_at"
	// FieldDeletedAt holds the string denoting the deleted_at field in the database.
	FieldDeletedAt = "deleted_at"
	// FieldReplyTo holds the string denoting the reply_to field in the database.
	FieldReplyTo = "reply_to"
	// EdgeChatRooms holds the string denoting the chat_rooms edge name in mutations.
	EdgeChatRooms = "chat_rooms"
	// EdgePostedBy holds the string denoting the posted_by edge name in mutations.
	EdgePostedBy = "posted_by"
	// EdgeLikedBy holds the string denoting the liked_by edge name in mutations.
	EdgeLikedBy = "liked_by"
	// EdgeReplyToEdge holds the string denoting the reply_to_edge edge name in mutations.
	EdgeReplyToEdge = "reply_to_edge"
	// EdgeReplies holds the string denoting the replies edge name in mutations.
	EdgeReplies = "replies"
	// Table holds the table name of the post in the database.
	Table = "posts"
	// ChatRoomsTable is the table that holds the chat_rooms relation/edge.
	ChatRoomsTable = "chat_rooms"
	// ChatRoomsInverseTable is the table name for the ChatRoom entity.
	// It exists in this package in order to avoid circular dependency with the "chatroom" package.
	ChatRoomsInverseTable = "chat_rooms"
	// ChatRoomsColumn is the table column denoting the chat_rooms relation/edge.
	ChatRoomsColumn = "post_chat_rooms"
	// PostedByTable is the table that holds the posted_by relation/edge.
	PostedByTable = "posts"
	// PostedByInverseTable is the table name for the Profile entity.
	// It exists in this package in order to avoid circular dependency with the "profile" package.
	PostedByInverseTable = "profiles"
	// PostedByColumn is the table column denoting the posted_by relation/edge.
	PostedByColumn = "profile_posts"
	// LikedByTable is the table that holds the liked_by relation/edge. The primary key declared below.
	LikedByTable = "profile_likes"
	// LikedByInverseTable is the table name for the Profile entity.
	// It exists in this package in order to avoid circular dependency with the "profile" package.
	LikedByInverseTable = "profiles"
	// ReplyToEdgeTable is the table that holds the reply_to_edge relation/edge.
	ReplyToEdgeTable = "posts"
	// ReplyToEdgeColumn is the table column denoting the reply_to_edge relation/edge.
	ReplyToEdgeColumn = "reply_to"
	// RepliesTable is the table that holds the replies relation/edge.
	RepliesTable = "posts"
	// RepliesColumn is the table column denoting the replies relation/edge.
	RepliesColumn = "reply_to"
)

// Columns holds all SQL columns for post fields.
var Columns = []string{
	FieldID,
	FieldImage,
	FieldContent,
	FieldProfileDisplayname,
	FieldProfileBirthYear,
	FieldProfileGender,
	FieldCoordinates,
	FieldCreatedAt,
	FieldUpdatedAt,
	FieldDeletedAt,
	FieldReplyTo,
}

// ForeignKeys holds the SQL foreign-keys that are owned by the "posts"
// table and are not defined as standalone fields in the schema.
var ForeignKeys = []string{
	"profile_posts",
}

var (
	// LikedByPrimaryKey and LikedByColumn2 are the table columns denoting the
	// primary key for the liked_by relation (M2M).
	LikedByPrimaryKey = []string{"profile_id", "post_id"}
)

// ValidColumn reports if the column name is valid (part of the table columns).
func ValidColumn(column string) bool {
	for i := range Columns {
		if column == Columns[i] {
			return true
		}
	}
	for i := range ForeignKeys {
		if column == ForeignKeys[i] {
			return true
		}
	}
	return false
}

var (
	// ImageValidator is a validator for the "image" field. It is called by the builders before save.
	ImageValidator func(string) error
	// ContentValidator is a validator for the "content" field. It is called by the builders before save.
	ContentValidator func(string) error
	// ProfileDisplaynameValidator is a validator for the "profile_displayname" field. It is called by the builders before save.
	ProfileDisplaynameValidator func(string) error
	// DefaultCreatedAt holds the default value on creation for the "created_at" field.
	DefaultCreatedAt func() time.Time
	// DefaultUpdatedAt holds the default value on creation for the "updated_at" field.
	DefaultUpdatedAt func() time.Time
	// UpdateDefaultUpdatedAt holds the default value on update for the "updated_at" field.
	UpdateDefaultUpdatedAt func() time.Time
)

// Order defines the ordering method for the Post queries.
type Order func(*sql.Selector)

// ByID orders the results by the id field.
func ByID(opts ...sql.OrderTermOption) Order {
	return sql.OrderByField(FieldID, opts...).ToFunc()
}

// ByImage orders the results by the image field.
func ByImage(opts ...sql.OrderTermOption) Order {
	return sql.OrderByField(FieldImage, opts...).ToFunc()
}

// ByContent orders the results by the content field.
func ByContent(opts ...sql.OrderTermOption) Order {
	return sql.OrderByField(FieldContent, opts...).ToFunc()
}

// ByProfileDisplayname orders the results by the profile_displayname field.
func ByProfileDisplayname(opts ...sql.OrderTermOption) Order {
	return sql.OrderByField(FieldProfileDisplayname, opts...).ToFunc()
}

// ByProfileBirthYear orders the results by the profile_birth_year field.
func ByProfileBirthYear(opts ...sql.OrderTermOption) Order {
	return sql.OrderByField(FieldProfileBirthYear, opts...).ToFunc()
}

// ByProfileGender orders the results by the profile_gender field.
func ByProfileGender(opts ...sql.OrderTermOption) Order {
	return sql.OrderByField(FieldProfileGender, opts...).ToFunc()
}

// ByCoordinates orders the results by the coordinates field.
func ByCoordinates(opts ...sql.OrderTermOption) Order {
	return sql.OrderByField(FieldCoordinates, opts...).ToFunc()
}

// ByCreatedAt orders the results by the created_at field.
func ByCreatedAt(opts ...sql.OrderTermOption) Order {
	return sql.OrderByField(FieldCreatedAt, opts...).ToFunc()
}

// ByUpdatedAt orders the results by the updated_at field.
func ByUpdatedAt(opts ...sql.OrderTermOption) Order {
	return sql.OrderByField(FieldUpdatedAt, opts...).ToFunc()
}

// ByDeletedAt orders the results by the deleted_at field.
func ByDeletedAt(opts ...sql.OrderTermOption) Order {
	return sql.OrderByField(FieldDeletedAt, opts...).ToFunc()
}

// ByReplyTo orders the results by the reply_to field.
func ByReplyTo(opts ...sql.OrderTermOption) Order {
	return sql.OrderByField(FieldReplyTo, opts...).ToFunc()
}

// ByChatRoomsCount orders the results by chat_rooms count.
func ByChatRoomsCount(opts ...sql.OrderTermOption) Order {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborsCount(s, newChatRoomsStep(), opts...)
	}
}

// ByChatRooms orders the results by chat_rooms terms.
func ByChatRooms(term sql.OrderTerm, terms ...sql.OrderTerm) Order {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborTerms(s, newChatRoomsStep(), append([]sql.OrderTerm{term}, terms...)...)
	}
}

// ByPostedByField orders the results by posted_by field.
func ByPostedByField(field string, opts ...sql.OrderTermOption) Order {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborTerms(s, newPostedByStep(), sql.OrderByField(field, opts...))
	}
}

// ByLikedByCount orders the results by liked_by count.
func ByLikedByCount(opts ...sql.OrderTermOption) Order {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborsCount(s, newLikedByStep(), opts...)
	}
}

// ByLikedBy orders the results by liked_by terms.
func ByLikedBy(term sql.OrderTerm, terms ...sql.OrderTerm) Order {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborTerms(s, newLikedByStep(), append([]sql.OrderTerm{term}, terms...)...)
	}
}

// ByReplyToEdgeField orders the results by reply_to_edge field.
func ByReplyToEdgeField(field string, opts ...sql.OrderTermOption) Order {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborTerms(s, newReplyToEdgeStep(), sql.OrderByField(field, opts...))
	}
}

// ByRepliesCount orders the results by replies count.
func ByRepliesCount(opts ...sql.OrderTermOption) Order {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborsCount(s, newRepliesStep(), opts...)
	}
}

// ByReplies orders the results by replies terms.
func ByReplies(term sql.OrderTerm, terms ...sql.OrderTerm) Order {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborTerms(s, newRepliesStep(), append([]sql.OrderTerm{term}, terms...)...)
	}
}
func newChatRoomsStep() *sqlgraph.Step {
	return sqlgraph.NewStep(
		sqlgraph.From(Table, FieldID),
		sqlgraph.To(ChatRoomsInverseTable, FieldID),
		sqlgraph.Edge(sqlgraph.O2M, false, ChatRoomsTable, ChatRoomsColumn),
	)
}
func newPostedByStep() *sqlgraph.Step {
	return sqlgraph.NewStep(
		sqlgraph.From(Table, FieldID),
		sqlgraph.To(PostedByInverseTable, FieldID),
		sqlgraph.Edge(sqlgraph.M2O, true, PostedByTable, PostedByColumn),
	)
}
func newLikedByStep() *sqlgraph.Step {
	return sqlgraph.NewStep(
		sqlgraph.From(Table, FieldID),
		sqlgraph.To(LikedByInverseTable, FieldID),
		sqlgraph.Edge(sqlgraph.M2M, true, LikedByTable, LikedByPrimaryKey...),
	)
}
func newReplyToEdgeStep() *sqlgraph.Step {
	return sqlgraph.NewStep(
		sqlgraph.From(Table, FieldID),
		sqlgraph.To(Table, FieldID),
		sqlgraph.Edge(sqlgraph.M2O, true, ReplyToEdgeTable, ReplyToEdgeColumn),
	)
}
func newRepliesStep() *sqlgraph.Step {
	return sqlgraph.NewStep(
		sqlgraph.From(Table, FieldID),
		sqlgraph.To(Table, FieldID),
		sqlgraph.Edge(sqlgraph.O2M, false, RepliesTable, RepliesColumn),
	)
}
